"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MapView = void 0;
exports.multiply = multiply;

var _reactNative = require("react-native");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable */
const LINKING_ERROR = `The package 'react-native-situm-wayfinding-plugin' doesn't seem to be linked. Make sure: \n\n` + _reactNative.Platform.select({
  ios: "- You have run 'pod install'\n",
  default: ''
}) + '- You rebuilt the app after installing the package\n' + '- You are not using Expo managed workflow\n';
const SitumWayfindingPlugin = _reactNative.NativeModules.SitumWayfindingPlugin ? _reactNative.NativeModules.SitumWayfindingPlugin : new Proxy({}, {
  get() {
    throw new Error(LINKING_ERROR);
  }

});

function multiply(a, b) {
  return SitumWayfindingPlugin.multiply(a, b);
}

var RCTMapView = (0, _reactNative.requireNativeComponent)('RCTMapView'); // , MapView, {}

class MapView extends _react.default.PureComponent {
  constructor(props) {
    super(props);
  }

  static get propTypes() {
    return {
      user: _propTypes.default.string.isRequired,
      apikey: _propTypes.default.string.isRequired,
      googleApikey: _propTypes.default.string.isRequired,
      buildingId: _propTypes.default.string.isRequired,
      onMapReady: _propTypes.default.func,
      onFloorChange: _propTypes.default.func,
      onPoiSelected: _propTypes.default.func,
      onPoiDeselected: _propTypes.default.func,
      onNavigationRequested: _propTypes.default.func,
      onNavigationError: _propTypes.default.func,
      onNavigationFinished: _propTypes.default.func
    };
  }

  render() {
    return /*#__PURE__*/_react.default.createElement(RCTMapView, this.props);
  }

}

exports.MapView = MapView;
//# sourceMappingURL=index.js.map